/*
 * HAL.h
 *
 * Created: 01.09.2020 20:35:55
 *  Author: GoldenAndy
 */ 


#ifndef HAL_H_
#define HAL_H_

	#include <avr/io.h>
	#include "defines.h"


	//------------------------------------------- Display
	void matrixSetReg(uint8_t regAddr, uint8_t regData);
	void matrixSetCsLevel(uint8_t csLevel);

	//------------------------------------------- Buzzer
	void soundOn(void);
	void soundOff(void);



	//-------------------------------------------  DS18B20
	void owPullUp(void);		
	void owPullDown(void);
	void owRelease(void);
	uint8_t owGetLevel(void);
	
	
	//------------------------------------------- KeyBoard
	#define KEY_MASK_SEL		_BV(PORTC0)
	#define KEY_MASK_DEC		_BV(PORTC1)
	#define KEY_MASK_INC		_BV(PORTC2)
	#define KEY_MASK_OK			_BV(PORTC3)
	uint8_t keyGetPress(void);

	//------------------------------------------- LightSensor
	uint8_t lightSensorGetLevel(void);
	
	//-------------------------------------------  DS3231 
	#define RTC_1HZ_INTERRRUPT	INT1_vect
	uint8_t getRtc1HzLevel(void);
	
	//------------------------------------------- System clock
	#define SYSTEMCLOCK_INTERRUPT_VECTOR		TIMER2_COMP_vect
	
	//-------------------------------------------  
	void hardwareInit(void);
	
#endif /* HAL_H_ */