#ifndef _Defines_
#define _Defines_ 1

	#define F_CPU 8000000UL
	
	#define HI(x) ((x)>>8)
	#define LO(x) ((x)& 0xFF)
	
	#define _CONCAT_EXPRESSION(a, b)	a ## b
	#define __OUTPORT(name)				_CONCAT_EXPRESSION(PORT, name)
	#define __INPORT(name)				_CONCAT_EXPRESSION(PIN, name)
	#define __DDRPORT(name)				_CONCAT_EXPRESSION(DDR, name)
	
	#define NOP							asm volatile ("nop" : : )
	#define WDR							asm volatile ("wdr" : : )
	
	#define __NO_INIT					__attribute__ ((section (".noinit")))
	
	#include <stdint.h>
	
	
	//------------------------------------------- sound
	#define SOUND_FREQ					4000
	#define _SIMPLE_SOUND_DURATION_		100
	typedef uint16_t soundPatternType;
	
	#define SOUNDPATTERN_HOURLY			0b0000000000001101
	#define SOUNDPATTERN_ALARM1			0b1000000000000000
	#define SOUNDPATTERN_ALARM2			0b1010000000000000
	#define SOUNDPATTERN_ALARM3			0b1101010000000000
	#define SOUNDPATTERN_ALARM4			0b1111011010100000
	
	//------------------------------------------- keys
	#define _KEY_BOUNCE_8BIT_
	#define _KEY_LONG_PRESS_TIME_		800
	#define _KEY_REPEAT_TIME_			80
	#define _KEY_BOUNCE_TIME_			30
	
	//------------------------------------------- System clock
	#define SYSTEMCLOCK_FREQ			1000u 
	  
	  
	//------------------------------------------- matrix
	#define INTENSITY_STEPDOWN_COUNTER		4 
	#define BLINK_PERIOD					500
	#define BLINK_HIDING_LEVEL				400
	
	//------------------------------------------- alarms
	typedef enum {
		asOff,
		asOnce,
		asWorkDays,
		asWeekends,
		asEveryDay
		} alarmStateType;
		;
	typedef struct {
		uint8_t			hour;
		uint8_t			minute;
		alarmStateType	state;
		} alarmRecordType; 
	
	#define ALARMS_COUNT		5
	
	//-------------------------------------------   
	
	#define SHOW_TIME_TIMEOUT			14000
	#define SHOW_TEMP_TIMEOUT			3500
	#define ALARMSETT_TIMEOUT			10000
	#define DATETIME_OFFER_TIMEOUT		8000
	#define SET_DATETIME_TIMEOUT		20000
	#define SET_MINUTE_TIMEOUT			65000
	
	typedef enum {
		mStartUp,
		mShowTime1,
		mShowDate,
		mShowTime2,
		mShowTemperature,
		mSelectAlarm,
		mSetAlarmHour,
		mSetAlarmMin,
		mSetAlarmMode,
		mShowSaved,
		mOfferSetTime,
		mOfferSetDate,
		mSetDate,
		mSetMonth,
		mSetYear,
		mSetHours,
		mSetMinutes,
		mAlarmPlay
		} modeType; 
	
	
#endif /*_Defines_*/
