/*
 * matrix.h
 *
 * Created: 03.09.2020 18:00:34
 *  Author: GoldenAndy
 */ 


#ifndef MATRIX_H_
#define MATRIX_H_

	#include "defines.h"
	#include "HAL.h"

	typedef enum {
		muNoUpdate = 0,
		muImmediate,
		muRollText,
		muRandom,
		muRollLeft,
		muRollRight,																				  
		muWaterFall,
		muRollUp,
		muRollDown       //   LAST_MATRIX_UPDATE_MODE -      
		} matrixUpdateType;
	
	#define FIRST_MATRIX_UPDATE_MODE		muRollLeft
	#define LAST_MATRIX_UPDATE_MODE			muRollDown
	
	void matrixExec(uint8_t ticks);

	void matrixClear (matrixUpdateType update);
	void matrixOutSymbol(uint8_t vPos, uint8_t symbID, matrixUpdateType update); 
	void matrixOutPStr(uint8_t vPos, const uint8_t str[], uint8_t maxSymbols, matrixUpdateType update);
	void matrixOutImage(uint8_t vPos, const uint8_t image[], matrixUpdateType update);
	//void matrixSetPixel(uint8_t col, uint8_t row, uint8_t pixel);
	void matrixSetIntensity(uint8_t intensity);
	void matrixInitRollText(uint8_t textBuf[], uint8_t tailStopPos);			   
	uint8_t matrixIsEffectExecute(void);

#endif /* MATRIX_H_ */