/*
 * rtc_ds3231.h
 *
 * Created: 27.11.2018 21:47:00
 *  Author: GoldenAndy
 */ 


#ifndef RTC_DS3231_H_
#define RTC_DS3231_H_
	
	#include <stdint.h>
	#define DISABLE_AUTO_DAYLIGHTSAVING	


	//uint8_t calculateDay(uint8_t date, uint8_t month, uint8_t shortYear);
	//     ,     .  = 1..7 (..).
	// !   -  BCD!!!	
	//    21 !
	
	uint8_t bcd2int(uint8_t bcdValue);  // BCD   
	uint8_t int2bcd(uint8_t intValue);  //    BCD
	uint8_t incBcd(uint8_t bcd);		// BCD++ 
	uint8_t decBcd(uint8_t bcd);		// BCD-- 

	
	uint8_t getLastMonthDate(uint8_t month, uint8_t shortYear); 
	//        .
	//   -  BCD!!!
	
	typedef struct {
		uint8_t seconds;
		uint8_t minutes;
		uint8_t hours;
		uint8_t day;
		uint8_t date;
		uint8_t month;
		uint8_t year;
		} timeStampType;
		
	extern timeStampType timeStamp;
		
	
	/************************************
	 *	initRTC -  
	 *	_____________________________
	 *	 i2c,  
	 *	,   .
	 ************************************/
	void initRTC(void);
	
	
	
	/************************************
	 *	writeTime -    
	 *	_________________________________
	 *	  
	 *	   .
	 *	    
	 *	 ,  
	 *	   
	 *	    .
	 *	  -  BCD :
	 *	  - 00h..23h 
	 *	,  - 00h..59h
	 *	  - 01h..07h (-)
	 *	 - 01h..28h/29h/30h/31h
	 *	 - 01h..12h
	 *	 - 00h..99h
	 ************************************/
	void writeTime(timeStampType* data);
	
	
	
	/************************************
	 *	execRtc -   
	 *	___________________________________
	 *	   
	 *	  ,
	 *	    
	 *	     
	 *	/      timeStamp
	 ************************************/
	void execRtc(uint8_t needRead);

#endif /* RTC_DS3231_H_ */