/*
 * EEPROM_CheckSum.c
 *
 * Created: 15.12.2015 
 * Author : aloktew
*/
 
#include <avr/io.h>
#include <util/atomic.h>
#include <avr/eeprom.h>

#include "EEPROM_CheckSum.h"

//   ,       .
uint8_t EESavedCRC EEMEM; 
 

uint8_t Calc_E2CRC(void)
{
      uint8_t crc=0;
      uint8_t * i;
	  uint8_t j;
      for (i=0; i<=(uint8_t*)E2END;i++) 
      {		
	  		if (i==&EESavedCRC) continue; //  ,      
            uint8_t inbyte = eeprom_read_byte(i);
            for (j=0;j<8;j++) 
            {
                  uint8_t mix = (crc ^ inbyte) & 0x01;
                  crc >>= 1;
                  if (mix) 
                        crc ^= 0x8C;
                  
                  inbyte >>= 1;
            }
      }
      return crc;
}
 
uint8_t EEPROM_IsGoodCRC(void)
{
	uint8_t EESum = eeprom_read_byte(&EESavedCRC);
	uint8_t EECalc= Calc_E2CRC();
	return EESum==EECalc;
}

void EEPROM_UpdateCRC(void)
{
	uint8_t EESum = eeprom_read_byte(&EESavedCRC);
	uint8_t EECalc= Calc_E2CRC();
	if (EESum==EECalc) return;
	eeprom_write_byte(&EESavedCRC,EECalc);
}



