/*
 * soundPatternPlay.h
 *
 *  Author: GoldenAndy
 */ 



#ifndef _SOUND_BLOCK_
#define _SOUND_BLOCK_

/************************************************************************/
/*                                      */
/************************************************************************/

/****************************************************************
 *	    #define:
 *
 *	_SIMPLE_SOUND_DURATION_ -   ,
 *		    execSound,  -  1  255
 *
 *	     (typedef)  :
 *	soundPatternType  -  8-, 16-  32-  
 *		    . 
 *
 *	   2  -    .
 *	          : void proc(void)
 *	         setSoundPlayControls.
 *	          
 *	           
 *
 ****************************************************************/

#include <stdint.h>
#include "defines.h"


//   / ,    
void setSoundPatternControls(void (*fSoundOn)(void), void (*fSoundOff)(void));

/****************************************************************
 *	  . 
 *	    - ,  - .
 *	       .
 ****************************************************************/
void setSoundPattern(soundPatternType soundPattern);

/****************************************************************
 *	  
 *	 0,         ,
 *	  1
 ****************************************************************/
uint8_t soundPatternIsEmpty(void);

/****************************************************************
 *	   . 
 *	     ,   
 *	ticks :	   ,      .  - 0..255
 *			           , 
 *			    1   
 *	init  :  True -  ,    ,    ticks .
 ****************************************************************/
void execSoundPattern(uint8_t ticks, uint8_t init);

#endif